﻿Public Class FormRelatorio
    Private Sub New(path As String, isEmbeddedResource As Boolean, dataSources As Dictionary(Of String, Object), Optional reportParameters As Dictionary(Of String, Object) = Nothing)
        InitializeComponent()

        ' path + isEmbeddedResource.
        If isEmbeddedResource Then
            Me.ReportViewer.LocalReport.ReportEmbeddedResource = path
        Else
            Me.ReportViewer.LocalReport.ReportPath = path
        End If

        ' dataSources.
        For Each dataSource In dataSources
            Dim reportDataSource = New Microsoft.Reporting.WinForms.ReportDataSource(dataSource.Key, dataSource.Value)
            Me.ReportViewer.LocalReport.DataSources.Add(reportDataSource)
        Next

        ' reportParameters.
        If reportParameters IsNot Nothing Then
            Dim reportParameterCollection = New List(Of Microsoft.Reporting.WinForms.ReportParameter)()

            For Each parameter In reportParameters
                Dim reportParameter = New Microsoft.Reporting.WinForms.ReportParameter(parameter.Key, parameter.Value.ToString())
                reportParameterCollection.Add(reportParameter)
            Next

            Me.ReportViewer.LocalReport.SetParameters(reportParameterCollection)
        End If
    End Sub

    Public Shared Sub ShowReport(path As String, isEmbeddedResource As Boolean, dataSources As Dictionary(Of String, Object), Optional reportParameters As Dictionary(Of String, Object) = Nothing)
        Dim formRelatorio = New FormRelatorio(path, isEmbeddedResource, dataSources, reportParameters)
        formRelatorio.Show()
    End Sub

    Private Sub FormRelatorio_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ReportViewer.RefreshReport()
    End Sub
End Class